Package org.optaplanner.core.config.localsearch.decider.acceptor.stepcountinghillclimbing

## Enum StepCountingHillClimbingType

- java.lang.Object
- - java.lang.Enum<StepCountingHillClimbingType>
  - - org.optaplanner.core.config.localsearch.decider.acceptor.stepcountinghillclimbing.StepCountingHillClimbingType

- All Implemented Interfaces:
    `Serializable`, `Comparable<StepCountingHillClimbingType>`

      public enum StepCountingHillClimbingType
      extends Enum<StepCountingHillClimbingType>

  Determines what increment the counter of Step Counting Hill Climbing.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `ACCEPTED_MOVE` | Every accepted move is counted.
    `EQUAL_OR_IMPROVING_STEP` | Every step that equals or improves the `Score` of the last step is counted.
    `IMPROVING_STEP` | Every step that improves the `Score` of the last step is counted.
    `SELECTED_MOVE` | Every selected move is counted.
    `STEP` | Every step is counted.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static StepCountingHillClimbingType` | `valueOf​(String name)` | Returns the enum constant of this type with the specified name.
    `static StepCountingHillClimbingType[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### SELECTED_MOVE

          public static final StepCountingHillClimbingType SELECTED_MOVE

      Every selected move is counted.

    - #### ACCEPTED_MOVE

          public static final StepCountingHillClimbingType ACCEPTED_MOVE

      Every accepted move is counted.

      Note: If `LocalSearchForagerConfig.getAcceptedCountLimit()` = 1, then this behaves exactly the same as {link #STEP}.

    - #### STEP

          public static final StepCountingHillClimbingType STEP

      Every step is counted. Every step was always an accepted move. This is the default.

    - #### EQUAL_OR_IMPROVING_STEP

          public static final StepCountingHillClimbingType EQUAL_OR_IMPROVING_STEP

      Every step that equals or improves the `Score` of the last step is counted.

    - #### IMPROVING_STEP

          public static final StepCountingHillClimbingType IMPROVING_STEP

      Every step that improves the `Score` of the last step is counted.

  - ### Method Detail

    - #### values

          public static StepCountingHillClimbingType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (StepCountingHillClimbingType c : StepCountingHillClimbingType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static StepCountingHillClimbingType valueOf​(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null